# Qmail install script by Robert Stan <robalo@opensys.ro>

killall sendmail 1>/dev/null 2>/dev/null

( cd usr/lib ; rm -rf sendmail >/dev/null)
( cd usr/lib ; ln -sf /var/qmail/bin/sendmail sendmail )
( cd usr/bin ; rm -rf sendmail >/dev/null)
( cd usr/bin ; ln -sf /var/qmail/bin/sendmail sendmail )
( cd usr/sbin ; mv sendmail sendmail.replaced )
( cd usr/sbin ; ln -sf /var/qmail/bin/sendmail sendmail )

chmod 622 var/qmail/queue/lock/trigger

# remove GID's and UID's
userdel alias >/dev/null
userdel qmaild >/dev/null
userdel qmaill >/dev/null
userdel qmailp >/dev/null
userdel qmailq >/dev/null
userdel qmailr >/dev/null
userdel qmails >/dev/null
groupdel nofiles >/dev/null
groupdel qmail >/dev/null

# create GID's and UID's
groupadd -g 96 nofiles >/dev/null
groupadd -g 97 qmail >/dev/null
useradd -g nofiles -u 91 -d /var/qmail/alias alias >/dev/null
useradd -g nofiles -u 92 -d /var/qmail qmaild >/dev/null
useradd -g nofiles -u 93 -d /var/qmail qmaill >/dev/null
useradd -g nofiles -u 94 -d /var/qmail qmailp >/dev/null
useradd -g qmail -u 95 -d /var/qmail qmailq >/dev/null
useradd -g qmail -u 96 -d /var/qmail qmailr >/dev/null
useradd -g qmail -u 97 -d /var/qmail qmails >/dev/null

# config-fast:
echo
echo -n "Enter your fully qualified host name: "
read fqdn
if [ -z "$fqdn" ]; then
  echo "I hope you know what you're doing ..."
fi
echo
echo Putting "$fqdn" into control/me...
echo "$fqdn" > /var/qmail/control/me
chmod 644 /var/qmail/control/me

( echo "$fqdn" | sed 's/^\([^\.]*\)\.\([^\.]*\)\./\2\./' | (
  read ddom
  echo Putting "$ddom" into control/defaultdomain...
  echo "$ddom" > /var/qmail/control/defaultdomain
  chmod 644 /var/qmail/control/defaultdomain
) )

( echo "$fqdn" | sed 's/^.*\.\([^\.]*\)\.\([^\.]*\)$/\1.\2/' | (
  read pdom
  echo Putting "$pdom" into control/plusdomain...
  echo "$pdom" > /var/qmail/control/plusdomain
  chmod 644 /var/qmail/control/plusdomain
) )

echo Putting "$fqdn" into control/locals...
echo "$fqdn" >> /var/qmail/control/locals
chmod 644 /var/qmail/control/locals

echo Putting "$fqdn" into control/rcpthosts...
echo "$fqdn" >> /var/qmail/control/rcpthosts
chmod 644 /var/qmail/control/rcpthosts
echo "Now qmail will refuse to accept SMTP messages except to $fqdn."
echo 'Make sure to change rcpthosts if you add hosts to locals or virtualdomains!'
